package cn.iocoder.yudao.module.reward.api.reward;

import cn.iocoder.yudao.module.reward.api.reward.dto.RedeemDetailForUserDTO;
import cn.iocoder.yudao.module.reward.api.reward.dto.RedeemRewardReqVO;
import cn.iocoder.yudao.module.reward.api.reward.dto.RedeemRewardRespDTO;

import java.util.List;

/**
 * 礼品兑换 api 接口
 */
public interface RedeemRewardApi {

    /**
     * 兑换礼品
     *
     * @param redeemRewardReqVO
     * @return
     */
    Boolean redeemReward(RedeemRewardReqVO redeemRewardReqVO);

    /**
     * 执行兑换事务
     *
     * @param redeemRewardReqVO
     * @param pointsRequire
     * @param rewardId
     */
    void executeRedeem(RedeemRewardReqVO redeemRewardReqVO, Integer pointsRequire, Long rewardId);

    /**
     * 批量兑换礼品
     *
     * @param redeemRewardReqVOList
     * @return
     */
    List<RedeemRewardRespDTO> redeemRewards(List<RedeemRewardReqVO> redeemRewardReqVOList);

    /**
     * 批量执行兑换事务
     *
     * @param redeemRewardReqVOList
     * @param pointsRequire
     * @param rewardId
     */
    void batchExecuteRedeem(List<RedeemRewardReqVO> redeemRewardReqVOList, Integer pointsRequire, Long rewardId);

    /**
     * 客户端获取礼品详情
     * @param redeemId
     * @return
     */
    RedeemDetailForUserDTO getRedeemDetailForUser(Long redeemId);

    /**
     * 兑换礼品发送验证码
     * @param memberId
     */
    void sendSmsCode(Long memberId);
}
